% This program takes as input the percentiles of KIPP data and calculates global bounds.
% import percentiles
percentiles=csvread('replication_kippformatlab.csv',0,0);

n=(size(percentiles,2))/2;
% initialize results
% define range of treatment effect sizes
numts=50;
tmax=max(max(percentiles(:,n+1:2*n)))-min(min(percentiles(:,1:n)));
tmin=min(min(percentiles(:,n+1:2*n)))-max(max(percentiles(:,1:n)));
tgrid=sort([tmin:((tmax-tmin)/(numts-2)):tmax,0]');
results=zeros(numts*size(percentiles,1),3);
% yes, impose stochastic increasingness:
fosd=[1,1];
graph=0;
% evaluate cdf bounds at t=0, so fraction hurt
for i=1:size(percentiles,1) 
    for tind=1:numts
        t=tgrid(tind,1);
        results((i-1)*numts+tind,1)=t;
        fprintf('on row %f out of %f, t = %f\n',i,size(percentiles,1),t);
        bounds(percentiles(i,(n+1):(2*n)),percentiles(i,1:n),t,fosd,graph)
        results((i-1)*numts+tind,2:3)=ans';
        results(((i-1)*numts+1):((i-1)*numts+tind),:)
    end;
    figure
    plot(results(((i-1)*numts+1):(i*numts),1),...
         results(((i-1)*numts+1):(i*numts),2),...
         results(((i-1)*numts+1):(i*numts),1),...
         results(((i-1)*numts+1):(i*numts),3));
end;

csvwrite('replication_kippfrommatlab.csv',results);
